//画像を扱うクレート
use image::{Rgba,ImageBuffer};
//ファイルダイアログを扱うクレート
use native_dialog::FileDialog;
//最初に呼ばれるメイン関数
fn main() {
  //色を返すクロージャ
  let draw = |x, _y| {
    //u8の灰色
    let gray = x as u8;
    //赤緑青アルファからなる色
    Rgba::<u8>([gray,gray,gray,255])
  };
  //256x256の画像を生成
  let img = ImageBuffer::from_fn(256, 256, draw);
  //ファイルダイアログ
  let path = FileDialog::new()
  //最初にデスクトップを開く
  .set_location("~/Desktop")
  //ファイルの種類をPNGだけに
  .add_filter("PNG Image", &["png"])
  //名前を付けて保存ダイアログ
  .show_save_single_file()
  //失敗した場合を無視
  .unwrap();
  //パスの場合分け
  match path {
    //パス名が存在した場合
    Some(path) => {
      //画像をパス名でファイルに保存
      img.save(path).unwrap();
    },
    //パス名がない場合
    None => return,
  };
}

