// サウンドを扱うクレート
use kira::{
	manager::{AudioManager, AudioManagerSettings,backend::DefaultBackend},
	sound::static_sound::{StaticSoundData, StaticSoundSettings},
};
//ファイルダイアログを扱うクレート
use native_dialog::FileDialog;
//スレッドを扱うクレート
use std::thread;
//時間の間隔を扱うクレート
use std::time::Duration;
//メイン関数
fn main() {
  // オーディオマネージャの生成
  let mut manager = AudioManager::<DefaultBackend>::new(AudioManagerSettings::default()).unwrap();
  //ファイルダイアログ
  let path = FileDialog::new()
  //最初にデスクトップを開く
  .set_location("~/Desktop")
  //ファイルの種類をOggだけに
  .add_filter("Ogg Sound", &["ogg"])
  //開くダイアログ
  .show_open_single_file()
  //失敗した場合を無視
  .unwrap();
  //パスの場合分け
  match path {
    //パス名が存在した場合
    Some(path) => {
      //サウンドの読み込み
      let sound_data = StaticSoundData::from_file(path, StaticSoundSettings::default()).unwrap();
      //サウンドの再生
      manager.play(sound_data.clone()).unwrap();
      //2秒スリープ
      thread::sleep(Duration::from_millis(2000));
    },
    //パス名がない場合
    None => return,
  };
}
